#version 330

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;
uniform mat4 bias;
uniform mat4 lightview;
uniform mat4 shadowprojection;

uniform vec3 lightposition;

in vec4 vertex;
in vec3 normal;
in vec2 tex_coords_in;

out vec3 normal_out;
out vec4 vertex_out;
out vec3 lightpos;
out vec2 tex_coords;
out vec4 shadow_tex_coords;

void main(void)
{
	normal_out = (model * vec4(normal, 0.0)).xyz;
	
	lightpos = lightposition;

	vertex_out = model * vertex;

	tex_coords = tex_coords_in;

	shadow_tex_coords = bias * shadowprojection * lightview * model * vertex;

	gl_Position = projection * view * model * vertex;
}  